import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.JsonNode;
import com.mashape.unirest.http.Unirest;
import com.mashape.unirest.http.exceptions.UnirestException;
import org.json.JSONArray;
import org.json.JSONObject;

import java.io.IOException;
import java.net.HttpURLConnection;
import java.net.ProtocolException;
import java.net.URL;

public class YouAreEll {

    private String underARock = "http://zipcode.rocks:8085";

    YouAreEll() {

    }

    public String get_ids(){

        try {
            HttpResponse<JsonNode> jsonResponse = Unirest.get(underARock + "/ids")
                    .header("accept", "application/json")
                    .asJson();

            return SimpleShell.prettyPrint(jsonResponse.getBody());

        } catch (UnirestException e) {
            return "Error";
        }

    }

    public String get_messages() {
        try {
            HttpResponse<JsonNode> jsonResponse = Unirest.get(underARock + "/messages")
                    .header("accept", "application/json")
                    .asJson();

            return SimpleShell.prettyPrint(jsonResponse.getBody());

        } catch (UnirestException e) {
            return "Error";
        }
    }

    public void postNewUser(Id id) {
        try {
            Unirest.post(underARock + "/ids")
                    .body(id.toJSON())
                    .asJson();

        } catch (UnirestException e) {
            System.out.println("Error");
        }

    }

    public void putNewName(Id id) {
        try {
            Unirest.put(underARock + "/ids")
                    .body(id.toJSON())
                    .asJson();

        } catch (UnirestException e) {
            System.out.println("Error");
        }

    }

    public boolean githubIdExists(String githubId) {
        String ids = get_ids();
        return ids.contains(githubId);
    }


    public String getMyMessages(String githubId) {
        try {
            HttpResponse<JsonNode> jsonResponse = Unirest.get(underARock + "/ids/" + githubId + "/messages")
                    .header("accept", "application/json")
                    .asJson();

            return SimpleShell.prettyPrint(jsonResponse.getBody());

        } catch (UnirestException e) {
            return "Error";
        }
    }

    public boolean messageExists(String message) {
        return get_messages().contains(message);
    }

    public void sendMessage(Message message) {
        try {
            Unirest.post(underARock + "/ids/" + message.getFromId() + "/messages")
                    .body(message.toJSON())
                    .asJson();

        } catch (UnirestException e) {
            System.out.println("Error");
        }

    }
}
